
#include <stdio.h>
#include <stdlib.h>
#include "..\..\..\bmp.h"
#include "..\..\..\j2k-codec.h"

void main(int ArgC, char **ArgV)
{
 void *j2k_image; int j2k_ver, width, height, components, bpp; unsigned char *buffer=0;

 if(ArgC<2){ printf("\n Please, specify the J2K file name!\n\n"); system("pause"); return; }

 j2k_ver = J2K_getVersion();

 if(j2k_ver < 0x110000) return; /* This way you can make sure the version is at least 1.1 (or any other required) */

 printf("\n J2K-Codec version: %x.%x (build %u)\n", (j2k_ver>>16)&0x0F, j2k_ver>>20, j2k_ver&0xFFFF); 

 j2k_image = J2K_EasyDecode(ArgV[1], &buffer, &width, &height, &components, NULL);
 if(!j2k_image) printf("\n J2K-Codec error: %s.\n", J2K_getLastErrorStr());
 else
 {
  printf("\n J2K-Codec image info: %ux%u, %u component(s).\n", width, height, components);

  /* Let's save the decoded image as BMP file */

  bpp=(components==1) ? 1 : 4;

  SaveAsBMP("decoded.bmp", buffer, width, height, bpp);
 }

 J2K_Close(j2k_image); /* It is safe to pass NULL here */
}
