
#include <stdio.h>
#include <stdlib.h>
#include "..\..\..\bmp.h"
#include "..\..\..\j2k-codec.h"

void main(int ArgC, char **ArgV)
{
 if(ArgC<2){ printf("\n Please, specify the J2K file name!\n\n"); system("pause"); return; }

 int j2k_ver = J2K_getVersion();

 if(j2k_ver < 0x100000) return; // This way you can make sure the version is at least 1.0 (or any other required)

 printf("\n J2K-Codec version: %x.%x (build %u)\n", (j2k_ver>>16)&0x0F, j2k_ver>>20, j2k_ver&0xFFFF); 


 J2K_Image j2k_image;

 int j2k_err = j2k_image.easyDecode(ArgV[1]); if(j2k_err!=J2KERR_SUCCESS){ printf("\n J2K-Codec error: %s.\n", j2k_image.errStr); return; }

 printf("\n J2K-Codec image info: %ux%u, %u component(s).\n", j2k_image.width, j2k_image.height, j2k_image.components);

 // Let's save the decoded image as BMP file

 int bpp=(j2k_image.components==1) ? 1 : 4;

 SaveAsBMP("decoded.bmp", j2k_image.buffer, j2k_image.width, j2k_image.height, bpp);

 // j2k_image.close(); Optional, it will be called from the destructor anyway
}
